#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/poll.h>

#define PIN_FILE      "/dev/biffirq"

int main(int argc, char** argv)
{
   struct pollfd fdset[1];
   int nfds = 1;
   int fd, timeout, rc;
   unsigned int nc = 1;
   char c;
   
   if ((fd = open(PIN_FILE, O_RDONLY)) < 0) {
      printf("Couldn't open " PIN_FILE "\n");
      return -1;
   }
   
   timeout = (3 * 60 * 1000);
 
   while (1) {
      memset((void*)fdset, 0, sizeof(fdset));

      fdset[0].fd = fd;
      fdset[0].events = POLLIN;
      
      printf("%u: poll() for read event.\n", nc++);
      
      rc = poll(fdset, nfds, timeout);
      
      if (rc < 0) {
         printf("poll() failed!\n");
         return -1;
      }
      
      if (rc == 0) {
         printf("poll() timed out.\n");
         return -1;
      }
            
      if (fdset[0].revents & POLLIN) {
         (void)read(fd, &c, 1);
         printf("poll() returned with POLLIN set, pin value is %c.\n", c);
      }
   }
}